// Copyright (C) 2008 David Bremner
//
// Author: David Bremner (bremner@unb.ca)
// Version: $Id$
//
// This file is part of lpmargin.
//
// lpmargin is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// lpmargin is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lpmargin.  If not, see <http://www.gnu.org/licenses/>.

#include "Partition.h"
Partition::Partition(int n){

  cardinality=n;

  this->first();
  primary.reserve(n/2+1);
}


void Partition::first(){
  primary.clear();
  primary.push_back(0);
  for (unsigned j=1; j<cardinality; j++)
    complement.insert(j);
}

bool Partition::last(){
  return ((primary.size() == 1) && (primary.back()+1==(cardinality)));
}

bool Partition::next(){
  if (this->last())
    return 0;

  const unsigned int smax=primary.back();

  if  ( (  primary.size() < cardinality/2-1 &&  (smax < cardinality-1) )||
	(  2*(primary.size()+1)==cardinality ) && ( smax < cardinality -2 ))
  {
    add_back(smax+1);
  } else {
    if (smax  < cardinality-(1+(2*primary.size()==cardinality))){
      // increment the last element;
      remove_back();
      add_back(smax+1);
    } else {
      // pop the last element, increment the _new_ last element.
      remove_back();
      increment_back();
    }
  }
  return 1;
}

std::ostream& operator<< (std::ostream& os, const Partition & sigma){
    primary_iterator i;
    complement_iterator j;

    os<< "[";
    for (i=sigma.begin(); i!=sigma.end(); i++){
      os<< *i << " ";
    }
    os <<"|";
    for ( j=sigma.cbegin(); j!=sigma.cend(); j++){
      os << *j << " ";
    }
    os << "]";
    return os;
}
