// Copyright (C) 2008 David Bremner
//
// Author: David Bremner (bremner@unb.ca)
// Version: $Id$
//
// This file is part of lpmargin.
//
// lpmargin is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// lpmargin is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lpmargin.  If not, see <http://www.gnu.org/licenses/>.
#ifndef DB_MATRIX_H
#define DB_MATRIX_H

#include "vector.h"

class matrix {
 private:
  int n_rows, n_cols;

  vector **data;

 public:
  matrix(int r, int c);
  int rows() const { return n_rows; }
  int cols() const { return n_cols; }
  vector & operator []  (int j) const{
    check(j>=0 && j<n_rows,check_bounds);
    return *data[j];
  }
};


inline ostream& operator<< (ostream& os, const matrix& m) {
  for (int j=0 ; j< m.rows(); j++){
    os << m[j];
  }
}

#endif
